package baldr;

import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Map;
import java.util.Properties;
import org.apache.lucene.index.*;
import org.apache.lucene.search.*;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.SimpleAnalyzer;

public class NumberOfTerms {
	
	public static void main(String[] args) throws IOException {
		// Remember to change this to which Index you want to optimize.
		//
		//String indexDir = Definitions.indexDir_bigram_100;
		//String indexDir = Definitions.indexDir_bigram_10;
		String indexDir = Definitions.indexDir_unigrams;
		Directory directory = null;
		IndexSearcher isearcher = null;
		IndexReader ireader = null;
		TermEnum terms = null;
		Analyzer analyzer = new DocumentAnalyzer(DocumentAnalyzer.Filters.PhraseFilter3);

		try {
		    directory = FSDirectory.getDirectory(indexDir);
		} catch(IOException e) {
		    e.printStackTrace();
		    System.exit(0);
		}

		try {
		    // adds 'false', so that the already existing index is erased.
		    //iwriter = new IndexWriter(directory, analyzer, false);
		    //iwriter.setUseCompoundFile(false);
		    isearcher = new IndexSearcher(directory);
		    ireader = isearcher.getIndexReader();

		} catch(IOException e) {
		    e.printStackTrace();
		    System.exit(0);
		}
		System.out.println("Has opened index: "+indexDir+"\nCollection terms..");
		terms = ireader.terms();
		int nr = 0;

		while(terms.next()) {
		    nr++;
		}

		System.out.println("Terms: # "+nr);
		isearcher.close();
		System.out.println("Closing index..");
		System.exit(0);

		//System.out.println("Has opened index: "+indexDir+"\nWill now optimize..");
		//iwriter.optimize();

		//iwriter.close();
		//System.out.println("Index has been optimized!");
		//System.exit(0);
		
		//String[] dirs = new String[] {"GX000", "GX001", "GX002", "GX003", "GX004", "GX005", "GX006", "GX007", "GX008", "GX009"};
		//String maindir = Definitions.baseDir;
		//
		//for(String dir : dirs) {
		//	fetchFiles(maindir+File.separator+dir);
		//}
		//
		//String[] partPath;
		//String trecCat, fileNo;
		//
		//String thisDir = System.getProperty("user.dir");
		////System.out.println("This dir: "+thisDir);
		//String homeDir = System.getProperty("user.home");
		//
		//
		//
		//for(String t : files) {
		//	partPath = t.split("/");
		//	
		//	trecCat = partPath[5];
		//	fileNo = partPath[6];
		//	
		//	files2.add(trecCat+"/"+fileNo);
		//}
		//System.out.println("Has "+files2.size()+" files in memory");
		//
		////Properties p = System.getProperties();
		//
		////Map<String, String> tmp = System.getenv();
		////for(Object t: p.keySet()) {
		////	System.out.println("Key: "+(String)t+" Value:"+p.get(t));
		////}
		//File outFile = new File(thisDir+File.separator+"trecFiles.txt");
		////BufferedOutputStream bos = new BufferedOutputStream( new FileWriter(outFile) );
		//BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
		//for(String t : files2) {
		//	bw.write(t+"\n");
		//}
		//bw.close();
		//System.out.println("Done");
		
		System.exit(0);
	}
}
