package baldr;

import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;

public class Gov2Document2 {
	private Document document;
	private Field docno = new Field("docno", "", Field.Store.YES, Field.Index.UN_TOKENIZED);
	private Field uri = new Field("uri", "", Field.Store.YES, Field.Index.TOKENIZED);
	private Field headline = new Field("headline", "", Field.Store.YES, Field.Index.TOKENIZED);
	private Field text = new Field("text", "", Field.Store.NO, Field.Index.TOKENIZED);
	
	public Gov2Document2() {
		//document = new Document();
	}
	
	public void setDocno(String docno) {
		this.docno.setValue(docno);
	}
	
	public void setUri(String uri) {
		this.uri.setValue(uri);
	}
	
	public void setHeadline(String headline) {
		this.headline.setValue(headline);
	}
	
	public void setText(String text) {
		this.text.setValue(text);
	}
	
	public Document document() {
		document = new Document();
		document.add(docno);
		document.add(uri);
		document.add(headline);
		document.add(text);
		
		return document;
	}
}
