package baldr;

import java.io.Serializable;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;

/*
 * Dette skal vre en dokumentpresentasjon av et TREC dokument..
 */

public class Trec96Document implements Serializable {
    private Document document;
    private String docno;
    private String headline;
    
    public Trec96Document(String docno, String headline, String date, String text) {
        // Ikke s mye  dytte inn her
        document = new Document();
        this.docno = docno;
        this.headline = headline;
        
        document.add(new Field("docno", docno , Field.Store.YES, Field.Index.UN_TOKENIZED));
        document.add(new Field("headline", headline, Field.Store.YES, Field.Index.TOKENIZED));
        document.add(new Field("date", date, Field.Store.YES, Field.Index.TOKENIZED));
        document.add(new Field("text", text, Field.Store.NO, Field.Index.TOKENIZED));
    }
    
    public Document document() {
        return document;
    }
    
    public String getDocno() {
        return this.docno;
    }
    public String getHeadline() {
        return this.headline;
    }
}
